%global debug_package %{nil}
%undefine _debugsource_packages
%undefine _missing_build_ids_terminate_build

Name:           frp
Version:        0.63.0
Release:        1%{?dist}
Summary:        Reverse proxy to expose local server behind NAT/firewall to Internet
License:        Apache 2.0
URL:            https://github.com/fatedier/frp
Packager:       Teddysun <i@teddysun.com>
Source0:        https://github.com/fatedier/frp/archive/refs/tags/v%{version}.tar.gz#/frp-%{version}.tar.gz
Source1:        https://github.com/fatedier/frp/raw/v%{version}/conf/frps.toml
Source2:        https://github.com/fatedier/frp/raw/v%{version}/conf/frpc.toml
#BuildRequires:  golang

%description
frp is a fast reverse proxy to help you expose a local server behind a NAT or
firewall to the Internet. As of now, it supports TCP and UDP, as well as HTTP
and HTTPS protocols, where requests can be forwarded to internal services by
domain name.

%prep
%setup -q -n %{name}-%{version}

%build
# https://pagure.io/go-rpm-macros/c/1cc7f5d9026175bb6cb1b8c889355d0c4fc0e40a
%undefine _auto_set_build_flags
LDFLAGS="-s -w -buildid="
env CGO_ENABLED=0 go build -v -trimpath -ldflags "${LDFLAGS}" -tags frps -o ./bin/frps ./cmd/frps
env CGO_ENABLED=0 go build -v -trimpath -ldflags "${LDFLAGS}" -tags frpc -o ./bin/frpc ./cmd/frpc

%install
%{__install} -d %{buildroot}%{_bindir}
%{__install} -m755 bin/* %{buildroot}%{_bindir}
%{__install} -d %{buildroot}%{_sysconfdir}/%{name}
%{__install} -p -m 644 %{S:1} %{buildroot}%{_sysconfdir}/%{name}/frps.toml
%{__install} -p -m 644 %{S:2} %{buildroot}%{_sysconfdir}/%{name}/frpc.toml

# shell completions
%{__install} -d -m 0755 %{buildroot}%{_datadir}/bash-completion/completions
./bin/frps completion bash > %{buildroot}%{_datadir}/bash-completion/completions/frps
./bin/frpc completion bash > %{buildroot}%{_datadir}/bash-completion/completions/frpc
%{__install} -d -m 0755 %{buildroot}%{_datadir}/zsh/site-functions
./bin/frps completion zsh > %{buildroot}%{_datadir}/zsh/site-functions/_frps
./bin/frpc completion zsh > %{buildroot}%{_datadir}/zsh/site-functions/_frpc
%{__install} -d -m 0755 %{buildroot}%{_datadir}/fish/vendor_completions.d
./bin/frps completion fish > %{buildroot}%{_datadir}/fish/vendor_completions.d/frps.fish
./bin/frpc completion fish > %{buildroot}%{_datadir}/fish/vendor_completions.d/frpc.fish

%{__install} -d %{buildroot}%{_unitdir}
cat > %{buildroot}%{_unitdir}/frps.service <<EOF
[Unit]
Description=frp server service
Documentation=https://github.com/fatedier/frp
After=network.target syslog.target
Wants=network.target

[Service]
CapabilityBoundingSet=CAP_NET_ADMIN CAP_NET_BIND_SERVICE
AmbientCapabilities=CAP_NET_ADMIN CAP_NET_BIND_SERVICE
ExecStart=/usr/bin/frps -c /etc/frp/frps.toml
ExecReload=/bin/kill -HUP \$MAINPID
TimeoutStopSec=5

[Install]
WantedBy=multi-user.target
EOF
cat > %{buildroot}%{_unitdir}/frpc.service <<EOF
[Unit]
Description=frp client service
Documentation=https://github.com/fatedier/frp
After=network.target syslog.target
Wants=network.target

[Service]
CapabilityBoundingSet=CAP_NET_ADMIN CAP_NET_BIND_SERVICE
AmbientCapabilities=CAP_NET_ADMIN CAP_NET_BIND_SERVICE
ExecStart=/usr/bin/frpc -c /etc/frp/frpc.toml
ExecReload=/bin/kill -HUP \$MAINPID
TimeoutStopSec=5

[Install]
WantedBy=multi-user.target
EOF


%files
%{_bindir}/%{name}*
%{_unitdir}/*.service
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/*.toml
%{_datadir}/bash-completion/completions/*
%{_datadir}/zsh/site-functions/*
%{_datadir}/fish/vendor_completions.d/*.fish
%license LICENSE
%doc doc/* *.md

%changelog
* Wed Jun 25 2025 Teddysun <i@teddysun.com> - 0.63.0-1
- Update version to 0.63.0

* Mon Apr 28 2025 Teddysun <i@teddysun.com> - 0.62.1-1
- Update version to 0.62.1

* Wed Apr 16 2025 Teddysun <i@teddysun.com> - 0.62.0-1
- Update version to 0.62.0

* Fri Mar 07 2025 Teddysun <i@teddysun.com> - 0.61.2-1
- Update version to 0.61.2

* Mon Dec 16 2024 Teddysun <i@teddysun.com> - 0.61.1-1
- Update version to 0.61.1

* Thu Oct 17 2024 Teddysun <i@teddysun.com> - 0.61.0-1
- Update version to 0.61.0

* Mon Aug 19 2024 Teddysun <i@teddysun.com> - 0.60.0-1
- Update version to 0.60.0

* Wed Jul 10 2024 Teddysun <i@teddysun.com> - 0.59.0-1
- Update version to 0.59.0

* Fri May 31 2024 Teddysun <i@teddysun.com> - 0.58.1-1
- Update version to 0.58.1

* Tue May 07 2024 Teddysun <i@teddysun.com> - 0.58.0-1
- Update version to 0.58.0

* Tue Apr 09 2024 Teddysun <i@teddysun.com> - 0.57.0-1
- Update version to 0.57.0

* Thu Mar 21 2024 Teddysun <i@teddysun.com> - 0.56.0-1
- Update version to 0.56.0

* Tue Mar 12 2024 Teddysun <i@teddysun.com> - 0.55.1-1
- Update version to 0.55.1

* Tue Mar 12 2024 Teddysun <i@teddysun.com> - 0.55.0-1
- Update version to 0.55.0

* Thu Feb 01 2024 Teddysun <i@teddysun.com> - 0.54.0-1
- Update version to 0.54.0

* Fri Dec 22 2023 Teddysun <i@teddysun.com> - 0.53.2-1
- Update version to 0.53.2

* Sat Dec 9 2023 Teddysun <i@teddysun.com> - 0.52.3-1
- Initial version 0.52.3
